# coding: utf-8

"""
    Magneto API

    Magneto API is the RESTful API for the Rely.io platform.

    The version of the OpenAPI document: v0.0.1
    Contact: contact@rely.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from magneto_api_client.models.scorecard_read import ScorecardRead
from typing import Optional, Set
from typing_extensions import Self

class CursorPageScorecardRead(BaseModel):
    """
    CursorPageScorecardRead
    """ # noqa: E501
    items: List[ScorecardRead]
    total: Optional[StrictInt] = Field(default=None, description="Total items")
    current_page: Optional[StrictStr] = Field(default=None, description="Cursor to refetch the current page")
    current_page_backwards: Optional[StrictStr] = Field(default=None, description="Cursor to refetch the current page starting from the last item")
    previous_page: Optional[StrictStr] = Field(default=None, description="Cursor for the previous page")
    next_page: Optional[StrictStr] = Field(default=None, description="Cursor for the next page")
    __properties: ClassVar[List[str]] = ["items", "total", "current_page", "current_page_backwards", "previous_page", "next_page"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CursorPageScorecardRead from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in items (list)
        _items = []
        if self.items:
            for _item_items in self.items:
                if _item_items:
                    _items.append(_item_items.to_dict())
            _dict['items'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CursorPageScorecardRead from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "items": [ScorecardRead.from_dict(_item) for _item in obj["items"]] if obj.get("items") is not None else None,
            "total": obj.get("total"),
            "current_page": obj.get("current_page"),
            "current_page_backwards": obj.get("current_page_backwards"),
            "previous_page": obj.get("previous_page"),
            "next_page": obj.get("next_page")
        })
        return _obj


